#include <cstring>
#include <cstdio>

#include <hash_map.h>
#include <map>

using namespace std;

int n;
char* nazwy[4];
long double jed[4][4];
int gj;
int bez_nazwy;

struct Wzorzec
{
  int oryginal;
  int id;

  Wzorzec(int _oryginal, int _id) : oryginal(_oryginal), id (_id) {}
};

hash_map<const char*, int> jid;
map <long double, Wzorzec> wzorce;

void main_input()
{
  n = 0;
  jid.clear();
  for (int i = 0; i < 4; i++)
    for (int j = 0; j < 4; j++)
      jed[i][j] = 0.0L;
  bez_nazwy = 0;

  int p;
  scanf("%d", &p);
  for (int i = 0; i < p; i++) {
    int k;
    char id1[11], id2[11], buf[2];
    scanf("%d ", &k);
    scanf("%s ", id1);
    scanf("%s ", buf); //sprawdzic spacje
    scanf("%d ", &k);
    scanf("%s", id2);
    
    if (jid.find(id1) != jid.end()) {
      jid.insert(pair<const char*, int>(id1, n));
      nazwy[n++] = strdup(id1);
    }
    if (jid.find(id2) != jid.end()) {
      jid.insert(pair<const char*, int>(id2, n));
      nazwy[n++] = strdup(id2);
    }
    int a1 = jid[id1];
    int a2 = jid[id2];
    jed[a1][a2] = k;
    jed[a2][a1] = 1.0L / k;
  }
  if (p == 0) {
    n = 1;
    bez_nazwy = 1;
  }
  for (int i = 0; i < n; i++)
    jed[i][i] = 1.0L;
}

void wybierz_jed()
{
  for (int k = 0; k < n; k++)
    for (int i = 0; i < n; i++)
      for (int j = 0; j < n; j++)
	if (jed[i][k] > 0.0L && jed[k][j] > 0.0L)
	  jed[i][j] = (long double)jed[i][k] * (long double)jed[k][j];

  gj = 0;
  for (int i = 1; i < n; i++)
    if (jed[0][i] < jed[0][gj])
      gj = i;
}
    
void wzorce_input()
{
  wzorce.clear();

  int w;
  scanf("%d", &w);
  for (int i = 0; i < w; i++) {
    int ilosc;
    char nazwa[11];
    scanf("%d ", &ilosc); //sprawdzic spacje
    scanf("%s", nazwa);
    if (bez_nazwy) {
      jid.insert(pair<const char*, int>(nazwa, 0));
      nazwy[0] = strdup(nazwa);
      bez_nazwy = 0;
    }
    int j = jid[nazwa];
    wzorce.insert(pair<long double, Wzorzec>(ilosc * jed[j][gj], 
					     Wzorzec(ilosc, j)));
  }
}

void answer() {
  int q;
  scanf("%d", &q);
  
  for (int i = 0; i < q; i++) {
    int ilosc;
    char nazwa[11];
    scanf("%d ", &ilosc);
    scanf("%s", nazwa);
    long double v = ilosc * jed[jid[nazwa]][gj];
    map<long double, Wzorzec>::iterator it = wzorce.lower_bound(v);
    Wzorzec odp;
    if (it == wzorce.end()) {
      it--;
      odp = *it;
    }
    else if (it->first > v) {
      if (it != wzorce.begin()) {
	long double y = it->first;
	it--;
	if (v - it->first <= y - v)
	  odp = *it;
      }
    }
    else
      odp = *it;
    printf("%d %s\n", odp.oryginal, nazwy[odp.id]);
  }
}

int main()
{
  int d;
  scanf("%d", &d);
  for (int z = 0; z < d; z++) {
    main_input();
    wybierz_jed();
    wzorce_input();
    answer();
  }

  return 0;
}
