#include <cstring>
#include <cstdio>

#include <map>

using namespace std;

int n;
char* nazwy[10];
long double jed[10][10];
int gj;
int bez_nazwy;

struct Wzorzec
{
  int oryginal;
  int id;

  Wzorzec(int _oryginal, int _id) : oryginal(_oryginal), id (_id) {}
};

struct strcompare
{
  bool operator()(const char* s1, const char* s2) {
    return strcmp(s1, s2) == -1;
  }
};

map<const char*, int, strcompare> jid;
map<long double, Wzorzec> wzorce;

void main_input()
{
  n = 0;
  jid.clear();
  for (int i = 0; i < 10; i++)
    for (int j = 0; j < 10; j++)
      jed[i][j] = 0.0L;
  bez_nazwy = 0;

  int p;
  scanf("%d", &p);
  for (int i = 0; i < p; i++) {
    int k;
    char id1[110], id2[111], buf[2000];
    scanf("%d ", &k);
    scanf("%s ", id1);
    scanf("%s ", buf); //sprawdzic spacje
    scanf("%d ", &k);
    scanf("%s", id2);
    
    if (jid.find(id1) == jid.end()) {
      jid.insert(pair<const char*, int>(strdup(id1), n));
      nazwy[n++] = strdup(id1);
    }
    if (jid.find(id2) == jid.end()) {
      jid.insert(pair<const char*, int>(strdup(id2), n));
      nazwy[n++] = strdup(id2);
    }
    int a1 = jid[id1];
    int a2 = jid[id2];
    jed[a1][a2] = k;
    jed[a2][a1] = 1.0L / k;
  }
  if (p == 0) {
    n = 1;
    bez_nazwy = 1;
  }
  for (int i = 0; i < n; i++)
    jed[i][i] = 1.0L;
}

void wybierz_jed()
{
  for (int k = 0; k < n; k++)
    for (int i = 0; i < n; i++)
      for (int j = 0; j < n; j++)
	if (jed[i][j] == 0.0L && jed[i][k] > 0.0L && jed[k][j] > 0.0L)
	  jed[i][j] = (long double)jed[i][k] * (long double)jed[k][j];
  
  gj = 0;
  for (int i = 1; i < n; i++)
    if (jed[0][i] > jed[0][gj])
      gj = i;
}
    
void wzorce_input()
{
  wzorce.clear();

  int w;
  scanf("%d", &w);

  for (int i = 0; i < w; i++) {
    int ilosc;
    char nazwa[100];
    scanf("%d ", &ilosc); //sprawdzic spacje
    scanf("%s", nazwa);
    if (bez_nazwy) {
      jid.insert(pair<const char*, int>(strdup(nazwa), 0));
      nazwy[0] = strdup(nazwa);
      bez_nazwy = 0;
    }
    int j = jid[nazwa];
    wzorce.insert(pair<long double, Wzorzec>(ilosc * jed[j][gj], 
					     Wzorzec(ilosc, j)));
  }
}

void answer() {
  int q;
  scanf("%d", &q);
  
  for (int i = 0; i < q; i++) {
    int ilosc;
    char nazwa[11];
    scanf("%d ", &ilosc);
    scanf("%s", nazwa);
    long double v = ilosc * jed[jid[nazwa]][gj];
    map<long double, Wzorzec>::iterator it = wzorce.lower_bound(v);
    Wzorzec odp(0, 0);
    if (it == wzorce.end()) {
      it--;
      odp = it->second;
    }
    else if (it->first > v && it != wzorce.begin()) {
      long double y = it->first;
      odp = it->second;
      it--;
      if (v - it->first <= y - v)
	odp = it->second;
    }
    else
      odp = it->second;
    printf("%d %s\n", odp.oryginal, nazwy[odp.id]);
  }
}

int main()
{
  int d;
  scanf("%d", &d);
  for (int z = 0; z < d; z++) {
    main_input();
    wybierz_jed();
    wzorce_input();
    answer();
  }

  return 0;
}
